package cn.com.tenlion.systembase.service.teamuser;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.systembase.pojo.dtos.teamuser.TeamUserDTO;
import cn.com.tenlion.systembase.pojo.vos.teamuser.TeamUserVO;
import cn.com.tenlion.systembase.pojo.bos.teamuser.TeamUserBO;
import cn.com.tenlion.systembase.pojo.pos.teamuser.TeamUserPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ITeamUserService
 * @Description: 综治队伍
 * @Author: CodeFactory
 * @Date: 2021-10-11 17:26:41
 * @Version: 3.0
 **/
public interface ITeamUserService {


    /**
     * 根据机构ID统计
     * @param institutionId
     * @return
     */
    Integer countByInstitutionId(String institutionId);

    /**
     * 新增综治队伍
     *
     * @param teamUserVO
     * @return
     */
    void save(TeamUserVO teamUserVO);

    /**
     * 新增综治队伍
     *
     * @param token
     * @param teamUserVO
     * @return
     */
    void save(String token, TeamUserVO teamUserVO);

    /**
     * 新增综治队伍
     *
     * @param teamUserVO
     * @return teamUserId
     */
    String saveReturnId(TeamUserVO teamUserVO);

    /**
     * 新增综治队伍
     *
     * @param token
     * @param teamUserVO
     * @return teamUserId
     */
    String saveReturnId(String token, TeamUserVO teamUserVO);

    /**
     * 删除综治队伍
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除综治队伍
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除综治队伍（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改综治队伍
     *
     * @param teamUserId
     * @param teamUserVO
     * @return
     */
    void update(String teamUserId, TeamUserVO teamUserVO);

    /**
     * 修改综治队伍
     *
     * @param token
     * @param teamUserId
     * @param teamUserVO
     * @return
     */
    void update(String token, String teamUserId, TeamUserVO teamUserVO);

    /**
     * 综治队伍详情
     *
     * @param params 参数Map
     * @return
     */
    TeamUserDTO get(Map<String, Object> params);

    /**
     * 综治队伍详情
     *
     * @param teamUserId
     * @return
     */
    TeamUserDTO get(String teamUserId);

    /**
     * 综治队伍详情
     *
     * @param params 参数Map
     * @return
     */
    TeamUserBO getBO(Map<String, Object> params);

    /**
     * 综治队伍详情
     *
     * @param teamUserId
     * @return
     */
    TeamUserBO getBO(String teamUserId);

    /**
     * 综治队伍详情
     *
     * @param params 参数Map
     * @return
     */
    TeamUserPO getPO(Map<String, Object> params);

    /**
     * 综治队伍详情
     *
     * @param teamUserId
     * @return
     */
    TeamUserPO getPO(String teamUserId);

    /**
     * 综治队伍列表
     *
     * @param params
     * @return
     */
    List<TeamUserDTO> list(Map<String, Object> params);

    /**
     * 综治队伍列表
     *
     * @param params
     * @return
     */
    List<TeamUserBO> listBO(Map<String, Object> params);

    /**
     * 综治队伍列表
     *
     * @param params
     * @return
     */
    List<TeamUserPO> listPO(Map<String, Object> params);

    /**
     * 综治队伍分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<TeamUserDTO>> listPage(ListPage page);

    /**
     * 综治队伍统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String uid, TeamUserVO teamUserVO);

    void updateKafka(String uid, TeamUserVO teamUserVO);

    void deleteKafka(String uid);

}